#pragma once

#define _DLLAPI extern "C" __declspec(dllexport)

typedef void (*pA100CallBackFunc)(unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char[], int);

//**********************A100*Protocol**************************
_DLLAPI unsigned int a100DataToUInt(const unsigned char data_arr[]);
_DLLAPI bool a100UIntToData(const unsigned int arg_val, unsigned char data_arr[]);

_DLLAPI float a100DataToFloat(const unsigned char data_arr[]);
_DLLAPI bool a100FloatToData(const float arg_val, unsigned char float_point_count, unsigned char data_arr[]);

//*******************Serial*port*******************************
_DLLAPI int a100GetSerialPortCurrentState() ;
_DLLAPI bool a100OpenSerialPort(const std::string &interface_name, const int &interface_speed);
_DLLAPI void a100CloseSerialPort();
_DLLAPI int a100SendCommand(unsigned char receiver_address, unsigned char sender_address, unsigned char command_code, unsigned char command_param, unsigned char data_array[], int write_timeout, int read_timeout, pA100CallBackFunc a100CallBackFunc, bool b_wait);
